<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="h-100 d-flex flex-row">

  <div
    *ngIf="tenant?.id && folder"
    class="left-panel h-100 p-4 bg-light overflow-auto">

    <app-breadcrumbs></app-breadcrumbs>

    <div
      *ngIf="folder"
      class="mt-3 h4 fw-bold overflow-hidden text-overflow-ellipsis"
      [innerText]="folder.name">
    </div>

    <div *ngFor="let block of userPreferences.folderViewBlockList;">
      <div
        *ngIf="block === folderViewBlockEnum.Actions && !!folder.subtype"
        class="mt-3 d-flex flex-row">
        <app-action-list
          (actualizeFolderEvent)="refreshFolder()"
          [folder]="folder"
          [desk]="currentDesk"
          [userPreferences]="userPreferences"
          [serverInfo]="serverInfo"
          [tenant]="tenant">
        </app-action-list>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.Draft"
        class="mt-3">
        <app-draft-fields
          *ngIf="folder && tenant?.id"
          [(folder)]="folder"
          [desk]="currentDesk"
          [tenantId]="tenant.id"
          [modificationsEnabled]="modificationEnabled"
          (folderChange)="onFolderUpdate()">
        </app-draft-fields>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.Metadata && tenant.id && (showStepMetadata || showSubTypeMetadata())"
        class="mt-3">

        <div class="border bg-white shadow-sm">

          <div class="border-bottom px-1 py-2">
            <fa-icon
              class="pointer text-primary"
              [icon]="isMetadataSectionCollapsed ? plusSquareIcon : minusSquareIcon"
              (click)="isMetadataSectionCollapsed = !isMetadataSectionCollapsed"
              [fixedWidth]="true">
            </fa-icon>
            <strong class="ms-3" [innerText]="folderViewBlockEnum.Metadata | folderViewBlockName"></strong>
          </div>

          <form *ngIf="!isMetadataSectionCollapsed" class="py-2 px-3 ls-form">
            <app-metadata-list
              *ngIf="showSubTypeMetadata()"
              [valuedMetadata]="folder.metadata"
              [subtype]="folder.subtype"
              [tenantId]="tenant.id"
              [isFolderEditable]="modificationEnabled"
              (valuedMetadataChanged)="onMetadataChanged($event)">
            </app-metadata-list>
            <app-step-metadata-list
              *ngIf="showStepMetadata"
              [folders]="[folder]"
              [metadataList]="stepMetadata">
            </app-step-metadata-list>
          </form>
        </div>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.Workflow"
        class="mt-3">
        <app-workflow-instance-snapshot
          [userPreferences]="userPreferences"
          [workflowInstance]="workflowInstance">
        </app-workflow-instance-snapshot>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.MainDocuments"
        class="mt-3">
        <app-document-list
          [isEditable]="modificationEnabled"
          [folder]="folder"
          [currentDesk]="currentDesk"
          [currentDocument]="currentDocument"
          [currentFolderViewBlock]="folderViewBlockEnum.MainDocuments"
          [userPreferences]="userPreferences"
          [serverInfo]="serverInfo"
          (documentSelected)="onDocumentSelected($event)">
        </app-document-list>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.AnnexeDocuments && !isPesFolder"
        class="mt-3">
        <app-document-list
          [isEditable]="isCurrentUserDeskOwner"
          [folder]="folder"
          [currentDesk]="currentDesk"
          [currentDocument]="currentDocument"
          [currentFolderViewBlock]="folderViewBlockEnum.AnnexeDocuments"
          [userPreferences]="userPreferences"
          [serverInfo]="serverInfo"
          (documentSelected)="onDocumentSelected($event)">
        </app-document-list>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.SignaturesReport && shouldShowSignatureReports()"
        class="mt-3">
        <app-document-list
          [isEditable]="isCurrentUserDeskOwner"
          [isSignatureReport]="true"
          [folder]="folder"
          [currentDesk]="currentDesk"
          [currentDocument]="currentDocument"
          [currentFolderViewBlock]="folderViewBlockEnum.SignaturesReport"
          [userPreferences]="userPreferences"
          [serverInfo]="serverInfo"
          (documentSelected)="onDocumentSelected($event)">
        </app-document-list>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.PublicAnnotation"
        class="mt-3">
        <app-annotation-display
          [folder]="folder"
          [currentFolderViewBlock]="folderViewBlockEnum.PublicAnnotation">
        </app-annotation-display>
      </div>

      <div
        *ngIf="block === folderViewBlockEnum.PrivateAnnotation"
        class="mt-3">
        <app-annotation-display
          [folder]="folder"
          [currentFolderViewBlock]="folderViewBlockEnum.PrivateAnnotation">
        </app-annotation-display>
      </div>

    </div>

  </div>

  <div class="flex-grow-1 mh-100 shadow d-flex flex-column flex-nowrap">

    <div class="flex-grow-1 bg-dark">

      <!--nameddest === hideAnnotationButtons-->
      <ng2-pdfjs-viewer
        *ngIf="folder && tenant.id && !isPesViewerActive && annotationsLoaded"
        [pdfSrc]="currentPdfSource"
        viewerId="MyUniqueID"
        openFile="false"
        print="false"
        fullScreen="false"
        (onPageChange)="onAnnotationEvent($event)"
        #pdfJsViewer>
      </ng2-pdfjs-viewer>

      <!--      TODO maybe add some sandbox attribute values to secure the iframe -->
      <iframe
        title="Lecteur PES"
        [src]=""
        class="border-0 bg-light w-100 h-100"
        *ngIf="folder && isPesViewerActive"
        #pesViewerFrame>
      </iframe>

    </div>

  </div>

</div>
